package com.bigflix.BigFlixMovies;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.app.pokktsdk.CoinResponseListener;
import com.app.pokktsdk.PokktManager;
import com.app.util.Comman;
import com.pokkt.videodemo.R;

public class OfferwallActivity extends Activity implements CoinResponseListener {
	int points = 0;
	EditText edt_points;
	CheckBox chbox_close_success;
	PokktManager pokktManager;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);

		setContentView(R.layout.offerwall);

		if(!Comman.isNetworkAvailable(this)){
			Toast.makeText(this, "Network Not Available!! Please Connect to Internet First.", Toast.LENGTH_LONG).show();
			finish();
		}

		pokktManager = MyApp.getPokktManager(this);
        PokktManager.setDebug(true);
        pokktManager.setCoinResponseListener(this);

        // this will be a unique id per user from developer side
        // developer is free to choose any String data point.
        pokktManager.setThirdPartyUserId("123456");

		edt_points = (EditText) findViewById(R.id.edt_max_points);
		chbox_close_success = (CheckBox) findViewById(R.id.chk_close_on_success);

		edt_points.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				edt_points.setFocusable(true);
				edt_points.setFocusableInTouchMode(true);
			}
		});

		findViewById(R.id.button).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				pokktManager.getCoins(OfferwallActivity.this,
						chbox_close_success.isChecked());

			}
		});

		findViewById(R.id.button_incomplete).setOnClickListener(
				new OnClickListener() {
					@Override
					public void onClick(View v) {
						pokktManager.getPendingCoins(OfferwallActivity.this);
					}
				});

		findViewById(R.id.button_max).setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				String temp = edt_points.getText().toString();
				try {
					if (!"".equals(temp)) {
						pokktManager.getCoins(OfferwallActivity.this, temp,
								chbox_close_success.isChecked());
					} else
						Toast.makeText(OfferwallActivity.this,
								"Please enter points", Toast.LENGTH_LONG)
								.show();
				} catch (Exception e) {
					Toast.makeText(OfferwallActivity.this,
							"Please enter valid points", Toast.LENGTH_LONG)
							.show();
				}
			}
		});

		if (points == 0)
			points = getSharedPreferences("MyOfferPrefs", MODE_PRIVATE).getInt(
					"points", 0);
		updateUI();
	}

	void updateUI() {
		((TextView) findViewById(R.id.points)).setText("Points earned: "
				+ points);
		getSharedPreferences("MyOfferPrefs", MODE_PRIVATE).edit()
				.putInt("points", points).commit();
	}

    protected void onResume() {
        super.onResume();
        pokktManager.getPendingCoins(this);
        pokktManager.checkCampaignAvailable(this);
    }

    @Override
    public void earnedCoins(int coins) {
        if (points == -1) {
            Toast.makeText(this, "No Points Earned", Toast.LENGTH_LONG).show();
        } else {
            this.points = this.points + coins;
            updateUI();
            Toast.makeText(this, "Points earned " + coins, Toast.LENGTH_LONG).show();
        }
    }

    @Override
    public void earnedCoins(int coins, String transaction_id) {
        if (points == -1) {
            Toast.makeText(this, "No Points Earned", Toast.LENGTH_LONG).show();
        } else {
            this.points = this.points + coins;
            updateUI();
            Toast.makeText(this, "Points earned " + coins
                    + " with transaction id "
                    + transaction_id, Toast.LENGTH_LONG).show();
        }
    }

    @Override
    public void requestFailed(String message) {
        Toast.makeText(OfferwallActivity.this, message, Toast.LENGTH_LONG).show();
    }
}
